#include <openssl/ssl.h>
#include <openssl/err.h>
#include <sys/socket.h>
#include <netdb.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>

  int sock,csock;
  struct sockaddr_in sock_addr, csock_addr;
  socklen_t csock_addr_len;
  char buf[1024+1];
  int len, so=1;
  SSL_CTX *ssl_ctx;
  SSL *tls;


/*
  TLS server realizovany pomoc OpenSSL.
  Spousti se bez prametru
*/
  int main(void)
  {
    //priprava    
    SSL_load_error_strings();
    SSLeay_add_ssl_algorithms();
    
    //bude to TLS server
		if (!(ssl_ctx = SSL_CTX_new(TLSv1_server_method()))) {
      ERR_print_errors_fp(stderr);
      return 1;
    }

    //nactu klice a certifikaty    
    if (SSL_CTX_use_certificate_file(ssl_ctx, "server.pem", SSL_FILETYPE_PEM) <= 0) {
      ERR_print_errors_fp(stderr);
      return 1;
    }
    if (SSL_CTX_use_PrivateKey_file(ssl_ctx, "server.key", SSL_FILETYPE_PEM) <= 0) {
      ERR_print_errors_fp(stderr);
      return 1;
    }
    if (!SSL_CTX_check_private_key(ssl_ctx)) {
      printf("Privatni klic neopovida certifikatu\n");
      return 1;
    }

    //otevru socket
    if ((sock = socket(PF_INET, SOCK_STREAM, 0)) == -1) {
      printf("Nelze vytvorit socket.\n");
      return 1;
    }
    //nastavim vlastnosti socketu
    so = 1;
    if(setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, (void*)&so, 4) == -1) {
      printf("Nelze nastavit vlastnosti socketu.\n");
      return 1;
    }

    sock_addr.sin_family = AF_INET;
    sock_addr.sin_addr.s_addr = INADDR_ANY;
    sock_addr.sin_port=htons(23987);

    //na socket napojim server    
    if(bind(sock, (struct sockaddr*)&sock_addr, sizeof(struct sockaddr_in)) == -1) {
      printf("Socket nelze spojit s portem\n");
      return 1;
    }
    //server zacne poslouchat
    if(listen(sock, 10) == -1) {
      printf("Server nemuze poslouchat na zadanem portu.\n");
      return 1;
    }
    
    printf("Server bezi na portu 23987...\n");
    while(1) {
      //prislo spojeni
      if((csock = accept(sock, (struct sockaddr*)&csock_addr, &csock_addr_len)) == -1) {
        printf("Nelze prijmout spojeni.\n");
        return 1;
      }

      //priprava na Handshake
      if (!(tls = SSL_new(ssl_ctx))) {
        ERR_print_errors_fp(stderr);
        return 1;
      }
      //ssl spojeni svazu s prijatym socketem
			if (!SSL_set_fd(tls, csock)) {
        ERR_print_errors_fp(stderr);
        return 1;
      }
      
			//provedeni handshaku
      if (SSL_accept(tls)!=1) {
        ERR_print_errors_fp(stderr);
        close(csock);
        continue;
      }   
    
      //prijmu zpravu od klienta
      if((len = SSL_read(tls, buf, 1024)) <= 0) {
        ERR_print_errors_fp(stderr);
        close(csock);
        continue;
      }
      
      buf[len]=0;
      printf("Prijato: %s\n", buf, len);

      //odeslu nazpet
      printf("Odesilam: %s\n", buf, strlen(buf));
      if((len = SSL_write(tls, buf, strlen(buf))) <= 0) {
        ERR_print_errors_fp(stderr);
      }
    }
    //uklid
    SSL_free(tls);
    close(sock);

    printf("Server byl ukoncen\n");
    return 0;
  } //main
